define(['backbone','underscore'],function($$,_){
	return $$.Model.extend({
		defaults:{
			element:null
			,keyCodes:"backspace,8,tab,9,enter,13,shift,16,ctrl,17,alt,18,pause,19,caps-lock,20,escape,27,space,32,page-up,33,page-down,34,end,35,home,36,left-arrow,37,up-arrow,38,right-arrow,39,down-arrow,40,insert,45,delete,46,0,48,1,49,2,50,3,51,4,52,5,53,6,54,7,55,8,56,9,57,a,65,b,66,c,67,d,68,e,69,f,70,g,71,h,72,i,73,j,74,k,75,l,76,m,77,n,78,o,79,p,80,q,81,r,82,s,83,t,84,u,85,v,86,w,87,x,88,y,89,z,90,left-window-key,91,right-window-key,92,select-key,93,numpad-0,96,numpad-1,97,numpad-2,98,numpad-3,99,numpad-4,100,numpad-5,101,numpad-6,102,numpad-7,103,numpad-8,104,numpad-9,105,multiply,106,add,107,subtract,109,decimal-point,110,divide,111,f1,112,f2,113,f3,114,f4,115,f5,116,f6,117,f7,118,f8,119,f9,120,f10,121,f11,122,f12,123,num-lock,144,scroll-lock,145,semi-colon,186,equal-sign,187,comma,188,dash,189,period,190,forward-slash,191,grave-accent,192,open-bracket,219,back-slash,220,close-braket,221,single-quote,222".split(',')
		}
		,_pressedMap:null
		,_keysObject:null
		,initialize:function(attributes,options){
			var i, self = this; e = attributes&&attributes.element?attributes.element:document.body;
			this._pressedMap = [];
			this._keysObject = {};

			for(i=0; i<this.attributes.keyCodes.length; i +=2){
				this._keysObject[this.attributes.keyCodes[i]] = this.attributes.keyCodes[i+1];
			}

			e.attributes["data-focus"] = 1;

						
			_.each('keydown,keypress,keyup'.split(','),function(type){
				document.body.addEventListener(type,function(event){
					if(!e.attributes["data-focus"])
						return;

					event.preventDefault();
					event.stopPropagation();


					switch(type){
						case 'keydown':
							self._pressedMap[event.keyCode] = true;
						break;
						case 'keyup':
							self._pressedMap[event.keyCode] = false;
						break;
					}

					self.trigger(type,event);
				},false);
			});
		}
		,IsDown:function(letter){
			if(letter===undefined || !this._keysObject.hasOwnProperty(letter))
				return false;

			return !!this._pressedMap[this._keysObject[letter]];
		}
		,GetKeyName:function(code){
			for(var i in this._keysObject){
				if(this._keysObject[i] == code)
					return i;
			}
			return null;
		}
	});
})