define(['backbone','underscore','math/vec2'],function($$,_,Vec2){
	return $$.Model.extend({
		defaults:{
			element:null
		}
		,_lmouseDown:false
		,_rmouseDown:false
		,_position:null
		,initialize:function(attributes,options){
			var self = this; e = attributes&&attributes.element?attributes.element:document.body;
			this._position = new Vec2;
			_.each('click,dblclick,mousedown,mouseup,mouseover,mousemove,mouseout'.split(','),function(type){
				e.addEventListener(type,function(event){
					var target = event.srcElement || event.target;
					
					if(target !== e)
						return;

					event.preventDefault();
					event.stopPropagation();

					switch(type){
						case 'mousedown':
							if(event.button == 0){
								self._lmouseDown = true;
							}else if(event.button == 2){
								self._rmouseDown = true;
							}
							
						break;
						case 'mouseup':
							if(event.button == 0){
								self._lmouseDown = false;
							}else if(event.button == 2){
								self._rmouseDown = false;
							}
						break;
						case 'mousemove':
							self._position.x = event.layerX;
							self._position.y = event.layerY;
						break;
					}

					self.trigger(type,event);
				},false);
			});
		}
		,IsDown:function(){
			return this._lmouseDown;
		}
		,IsRDown:function(){
			return this._rmouseDown;
		}
		,GetPosition:function(){
			return new Vec2(this._position.x,this._position.y);
		}
	});
})