define(['game','editor/console','underscore', 'tools', 'editor/gui'],function(Game,Console,_,tools,Gui){
	return Game.extend({
		defaults:_.extend({},Game.prototype.defaults,{
			'name': 	'editor'
			,'zoom': 1
			,'scaleMode': 'keepRatio'
		})
		,console:null
		,gui:null
		,initialize:function(attributes, options){
			var self=this;
			Game.prototype.initialize.apply(this,arguments);
			
			this.console = new Console();
			this.console.on("input",function(argv){
				var m="console_" + argv[0];
				if(self[m]){
					argv.splice(0,1);
					self[m].apply(self,argv);
				}
			});

			/*this.dom.style.position = 'absolute';
			this.dom.style.top = 0;
			this.dom.style.left = 0;
			this.set('resolutionX', window.innerWidth);
			this.set('resolutionY', window.innerHeight);*/

			this.gui = new Gui({game:this});
		}
		,console_MakeScene:function(name, sceneclass){
			cfg = {
				name: name || this.console.Prompt("enter scene name")
			};
			if(sceneclass){
				cfg.sceneclass = sceneclass;
			}
			this.SetScene(cfg);
		}
		,console_SceneAddEntity:function(name, entityclass){
			var scene = this.get("scene"), cfg;
			if(!scene){
				tools.Warn("there is no scene to add an entity to");
				return;
			}

			cfg = {
				name: name || this.console.Prompt("enter entity name")
			};
			
			entityclass = entityclass || 'entities/entity';

			require([entityclass],function(Entity){
				scene.AddEntity(new Entity(cfg));
			});
		}
		,console_SceneEntityAddModule:function(entityname, modulename, moduleclass){
			var scene = this.get("scene"),ent;

			if(!scene){
				tools.Warn("scene does not exist");
				return;
			}

			entityname = entityname || this.console.Prompt("enter entity name");
			modulename = modulename || this.console.Prompt("enter entity module name");
			moduleclass = moduleclass || this.console.Prompt("enter entity module class");
			
			ent = scene.GetEntityByName(entityname);

			if(!ent){
				tools.Warn("entity does not exist");
				return;
			}

			require([moduleclass],function(Module){
				if(!Module){
					tools.Warn("module class does not exist");
					return;
				}
				ent.AddModule(modulename, new Module({entity:this, name:modulename}));
			});
		}
		,console_SceneEntityModuleSetAttribute:function(entityname, modulename, key, value){
			var scene = this.get("scene"),ent,mod;
			if(!scene){
				tools.Warn("scene does not exist");
				return;
			}
			ent = scene.GetEntityByName(entityname || this.console.Prompt("enter entity name"));
			if(!ent){
				tools.Warn("entity does not exist");
				return;
			}
			mod = ent.GetModuleByName(modulename || this.console.Prompt("enter module name"));
			if(!mod){
				tools.Warn("entity does not exist");
				return;
			}

			mod.set(
				key || this.console.Prompt("enter attribute name")
				,value || this.console.Prompt("enter attribute value")
			);
		}
	});
});