define(['backbone','editor/gui','entities/entity','scenes/scene','entities/container','entities/module','tools'],function($$,Gui,Entity,Scene,Container,Module,tools){
	return $$.Model.extend({
		defaults:{
			'gui':null
		}
		,initialize:function(attributes,options){
			if(!attributes || !attributes.gui)
				return;

			var gui = this.get("gui"), self = this;
			gui.on("action",function(action,element){
				var func = "On" + action.substr(0,1).toUpperCase() + action.substr(1);
				if(self[func]){
					self[func](element);
				}
			});
		}
		
		,OnAddEntity:function(){
			var gui=this.attributes.gui,ent,sO = gui.get("selectedObject");

			if(sO && sO instanceof Container){
				sO.AddEntity(ent = new Entity);
				gui.set("selectedObject",ent);
			}
		}
		,OnDuplicateEntity:function(){
			var gui=this.attributes.gui,copy, sO = gui.get("selectedObject");

			if(sO && sO instanceof Entity && sO.get("parent")){
				copy = sO.toJSON();
				copy.name += " copy";
				sO.get("parent").AddEntity(copy = new Entity(copy));
				gui.set("selectedObject", copy);
			}
		}
		,OnRemoveEntity:function(){
			var gui=this.attributes.gui,parent, sO = gui.get("selectedObject");
			if(sO && sO instanceof Entity && sO.get("parent")){
				(parent = sO.get("parent")).RemoveEntity(sO);
				gui.set("selectedObject", null);
			}
		}
		
		,OnAddScene:function(){
			//todo
		}
		,OnDuplicateScene:function(){
			//todo
		}
		,OnRemoveScene:function(){
			//todo
		}

		,OnAddModule:function(){

		}
		,OnDuplicateModule:function(){
			var gui = this.attributes.gui,ent, copy, sO = gui.get("selectedObject");
			if(!(sO instanceof Module)){
				return;
			}

			if(sO.get("entity")){
				ent = sO.get("entity");
				copy = sO.toJSON();
				copy.name += " copy";
				ent.AddModule(copy.name,copy);
			}
		}
		,OnRemoveModule:function(){
			var gui = this.attributes.gui, sO = gui.get("selectedObject");
			if(!(sO instanceof Module)){
				return;
			}

			if(sO.get("entity")){
				sO.get("entity").RemoveModule(sO);
				gui.set("selectedObject", null);
			}
		}

		,OnCut:function(){
			var gui = this.attributes.gui, sO = gui.get("selectedObject");

			if(!sO){
				return;
			}

			gui.set("clipboardObject",sO);
			gui.set("clipboardObjectIsCut",true);
		}
		,OnCopy:function(){
			var gui = this.attributes.gui, sO = gui.get("selectedObject");

			if(!sO){
				return;
			}

			gui.set("clipboardObject",sO);
			gui.set("clipboardObjectIsCut",false);
		}
		,OnPaste:function(){
			var gui = this.attributes.gui, sO = gui.get("selectedObject"), cbO = gui.get("clipboardObject"), isCut = gui.get("clipboardObjectIsCut")||false, copy;

			if(!sO || !cbO || (isCut&&sO===cbO) || !(sO instanceof Container)){
				return;
			}

			if(isCut){
				if(cbO instanceof Entity){
					if(cbO.get("parent")){
						cbO.get("parent").RemoveEntity(cbO);
					}
					sO.AddEntity(cbO);
					gui.set("selectedObject", cbO);
				}else if(cbO instanceof Module && sO instanceof Entity){
					if(cbO.get("entity")){
						cbO.get("entity").RemoveModule(cbO);
					}
					
					sO.AddModule(cbO.get("name"), cbO.toJSON());
					gui.set("selectedObject", sO.GetModuleByName(cbO.get("name")));
					delete cbO;
				}
			}else{
				copy = cbO.toJSON();
				copy.name += " copy";

				if(cbO instanceof Entity){
					sO.AddEntity(copy = new Entity(copy));
					gui.set("selectedObject", copy);
				}else if(cbO instanceof Module && sO instanceof Entity){
					sO.AddModule(copy.name,copy);
					gui.set("selectedObject", sO.GetModuleByName(copy.name));
				}
			}
		}
	});
});