define(['jquery','bootstrap','backbone','underscore'],function($,bs,$$,_,Button){
	return $$.Model.extend({
		defaults:{
			"tagtype": "button"
			,"disabled": false
			,"style": null
			,"size": "btn-small"
			,"label": "Label"
			,"htmlattributes":null
		}
		,element:null
		,initialize:function(attributes,options){
			this.on("change:disabled",function(){
				this.GetElement().toggleClass("disabled",this.get("disabled"));
			});

			this.on("change:style",function(){
				this.InitElement();
			});

			this.on("change:size",function(){
				this.InitElement();
			});

			this.on("change:htmlattributes",function(){
				this.InitElement();
			});

			this.on("change:tagtype",function(){
				this.InitElement();
			});
		}
		,InitElement:function(){
			var tmp;
			if(!this.element){
				this.element = $('<' + this.get("tagtype") + '>');
			}else{
				this.element.replaceWith(tmp = $('<' + this.get("tagtype") + '>'));
				this.element = tmp;
			}

			this.element.addClass("btn").html(this.get("label"));
			
			if(this.get("style")){
				this.element.addClass(this.get("style"));
			}

			if(this.get("size")){
				this.element.addClass(this.get("size"));
			}

			if(this.get("disabled")){
				this.element.addClass("disabled");
			}
			
			if(this.get("htmlattributes")){
				this.element.attr(this.get("htmlattributes"));
			}
		}
		,GetElement:function(){
			if(!this.element){
				this.InitElement();
			}
			return this.element;
		}
	})
});