define(['underscore','backbone','jquery','bootstrap','editor/widget','tools'],function(_,$$,$,bs,Widget,tools){
	var pcount = 0;
	return $$.Model.extend({
		defaults:{
			'id':null
			,'name':'unnamed-widget'
			,'parent':null
			,'selector':null
			,'role':null
			,'width':'auto'
			,'height':'auto'
			,'positioning':'dockleft'
			,'scrollable':true
			,'widgets':null
		}
		,container:null
		,widgets:null
		,initialize:function(attributes,options){
			this.set("id",pcount++);
			this.set("selector","editor_pane_"+pcount);
			this.InitContainer();
			this.InitWidgets();
		}
		,InitContainer:function(){
			this.container = $('<div id="'+this.get('selector')+'"/>').addClass('pane');
		}
		,GetContainer:function(){
			return this.container;
		}
		,InitWidgets:function(){
			var self = this,index=0;
			this.widgets = new $$.Collection;
			this.widgets.comparator = function(widget){
				return widget.get("index");
			}
			this.widgets.on("add",function(widget){
				widget.GetContainer().appendTo(self.GetContainer());
			});

			this.widgets.on("sort",function(){
				//self.GetContainer().empty();
				this.each(function(w){
					self.GetContainer().append(w.GetContainer());
				});
			});

			if(this.get("widgets")){
				_.each(this.get("widgets"),function(w){
					if(!w['class']){
						return;
					}
					w.parent = self;
					w.index = index++;
					require([w['class']],function(WidgetClass){
						var widget = new WidgetClass(w);
						if(!(widget instanceof Widget)){
							tools.Warn(w['class'] + " was used as a widget, but does not extend from the Widget class, this may cause problems.");
						}
						self.widgets.add(widget);
					});
				});
			}
		}
	});
});