 var Common = require('./common.js')
 ,http = require('http')
 ,net = require('net')
 ,fs = require('fs')
 ,mime = require('mime')
 ,controller = require('./controller.js')
 ;

 module.exports = Common.Backbone.Model.extend({
 	defaults:{
 		serveAt:"127.0.0.1"
 		,port:1337
 		,rootdir:'../../../'
 		,projector:'/assets/editor/tpl/projector.html'
 	}
 	,http:null
 	,dbg:null
 	,initialize:function(attributes,options){
 		var self=this;
 		(this.http = http.createServer(function(req,res){self.OnRequest(req,res)})).listen(this.get("port",this.get("serveAt")));
 		console.log("Editor Server Running at "+this.get("serveAt")+":"+this.get("port"));
 	}
 	,OnRequest:function(request, response){
 		var self=this, url = request.url=="/"||!request.url.length?this.get("projector"):request.url;

 		this.GetFile("."+url,function(filecontent,filepath,mime){
 			response.writeHead(200,{'Content-Type':mime});
 			response.end(filecontent,'utf-8');
 		},function(){
 			self.GetController("."+request.url, function(controller){
 				if(controller){
 					controller.dispatch(request,response);
 					response.end();
 				}else{
 					response.writeHead(404);
 					response.end();
 				}
 			});
 		});
 	}
 	,GetFile:function(filepath,success,failure){
 		filepath = this.get("rootdir") + filepath;
		
 		fs.realpath(filepath,null,function(error, resolvedPath){
 			if(error){
 				failure&&failure();
 				return;
 			}

 			filepath = resolvedPath;

 			fs.exists(filepath,function(exists){
				if(exists){
					fs.readFile(filepath,function(error,content){
						if(error){
							console.log("error reading file "+filepath);
							failure&&failure();
						}else{
							success&&success(content,filepath,mime.lookup(filepath));
						}
					});
				}else{
					console.log("error reading file "+filepath);
					failure&&failure();
				}
			});	
 		});
 	}
 	,GetController:function(url,callback){
 		if(!url || url.match(/\.\./) || !url.match(/^\.\/controller/)){
 			callback&&callback(null);
 			return;
 		}

 		if(this.ModuleExists(url)){
 			var controllerModule = require(url);
 			if(! controllerModule.prototype instanceof controller){
 				throw new Error(url + " is not a controller module");
 			}
 			callback&&callback(new controllerModule({server:this}));
 		}else{
 			callback&&callback(null);
 		}
 	}
 	,ModuleExists:function(module){
 		try{
 			require.resolve(module);
 			return true;
 		}catch(e){
 			return false;
 		}
 	}
 });