define(['underscore','backbone','jquery','bootstrap','tools'],function(_,$$,$,bs,tools){
	var wcount = 0;
	return $$.Model.extend({
		defaults:{
			'id':null
			,'name':'unnamed-widget'
			,'title':null
			,'parent':null
			,'selector':null
			,'index':0
			,'template':'<div id="<%= selector %>" class="widget"><h4 data-action="collapse" class="title"><%= title %></h4></div>'
			,'collapsable': true
			,'collapsed': false
			,'widgetBodyTemplateFile': null
			,'widgetBodyCssClass':'body'
		}
		,container:null
		,initialize:function(attributes,options){
			this.set("id",wcount++);
			this.set("selector","editor_widget_"+wcount);
			this.InitContainer();
		}
		,InitContainer:function(){
			var self = this, collapse, widgetTpl = _.template(this.get("template"),{
				'selector': this.get("selector")
				,'title': this.get("title") || this.get("name") || ""
			});

			this.container = $(widgetTpl);
			
			if(this.GetWidgetBody()){
				this.container.append(this.GetWidgetBody());
			}

			this.container.click(function(e){
				var target = $(e.srcElement || e.target);
				
				if(!target.data("action")){
					if(target.parent(":first").data("action")){
						target = target.parent(":first");
					}else{
						return true;	
					}
				}
				e.preventDefault();
				e.stopPropagation();
				self.trigger("action:"+target.data("action"),target);
				self.trigger("action",target.data("action"),target);
			});

			this.on("action:collapse", function(){
				if(self.get("collapsable")){
					self.set("collapsed",!self.get("collapsed"));
				}
			});

			this.on("change:collapsed",collapse = function(){
				self.container.toggleClass("collapsed",!!self.attributes.collapsed);
			});

			self.container.attr("data-widget-index",self.get("index"));
			self.on("change:index",function(){
				self.container.attr("data-widget-index",self.get("index"));
			});
			
			collapse();
		}
		,GetContainer:function(){
			return this.container;
		}
		,widgetBodyTemplate: null
		,widgetBody: null
		,GetWidgetBody:function(forceRebuild){
			if(!forceRebuild && this.widgetBody)
				return this.widgetBody;

			if(!this.widgetBodyTemplate){
				if(!this.get('widgetBodyTemplateFile')){
					return (this.widgetBody = $("<div class='"+this.get("widgetBodyCssClass")+"' />"));
				}else{
					this.widgetBodyTemplate = tools.FileGetContents(this.get('widgetBodyTemplateFile'));
					if(!this.widgetBodyTemplate)
						return (this.widgetBody = $("<div class='"+this.get("widgetBodyCssClass")+"' />"));
				}
			}
			var tpl = _.template(this.widgetBodyTemplate,this.attributes);
			this.widgetBody = $("<div class='"+this.get("widgetBodyCssClass")+"' />").html(tpl);
			return this.widgetBody;
		}
		,Show:function(){
			this.GetContainer().show();
		}
		,Hide:function(){
			this.GetContainer().hide();
		}
	});
});