define(['editor/widget','jquery','tools','underscore'],function(Widget,$,tools,_){
	return Widget.extend({
		defaults:_.extend({},Widget.prototype.defaults,{
			'title': 'Attributes'
			,'widgetBodyTemplateFile': 'assets/editor/tpl/widgets/attributes.tpl'
			,'targetObject':null
			,'inputSize':'input-medium'
		})
		,initialize:function(attributes,options){
			Widget.prototype.initialize.apply(this,arguments);
			var self = this, editor = this.get("parent").get("parent"), target = null;
			
			this.attributes.widget = this;
			this.attributes._ = _;

			editor.on("change:selectedObject",function(){
				self.OnSelectedObjectChanged(this.get("selectedObject"));
			});

			this.on("action:callWizard",function(button){
				editor.ObjectAttributeGetWizard(self.get("targetObject"),button.attr("data-key"),function(wizard){
					if(!wizard)
						return;
					wizard.on("change",function(){
						self.OnSelectedObjectChanged(self.get("targetObject"));
					});
				});
			});

			target = editor.get("selectedObject") || this.get("targetObject");

			if(target){
				this.OnSelectedObjectChanged(target);
			}


		}
		,OnSelectedObjectChanged:function(obj){
			this.set("targetObject",obj);

			if(this.widgetBody)
				this.widgetBody.remove();

			var self=this,newBody = this.GetWidgetBody(true), editor = self.get("parent").get("parent");

			newBody.find("[data-key!='']").change(function(e){
				var el = $(this), val=null;
				switch(el.attr("type")){
					case "text":
						val = el.val()||"";
					break;
					case "checkbox":
						val = !!el.filter(":checked").length;
					break;
					case "number":
						val = Number(el.val()||0);
					break;
				}
				obj.set(el.data("key"),val);
				e.stopPropagation();
				self.trigger("change");
				editor.trigger("change:selectedObject",editor,editor.attributes.selectedObject);
			});

			this.GetContainer().append(newBody);
		}
	});
});