define(['editor/widget','jquery','tools','underscore'],function(Widget,$,tools,_){
	return Widget.extend({
		defaults:_.extend({},Widget.prototype.defaults,{
			'title': 'Game View'
			,'template':'<div id="<%= selector %>" class="widget gameview-widget"><h4 data-action="collapse" class="title"><%= title %></h4></div>'
			,'widgetBodyTemplateFile': 'assets/editor/tpl/widgets/gameview.tpl'
			,'gameClass':'game'
			,'collapsed': false
			,'collapsable': false
		})
		,gameObject:null
		,initialize:function(attributes,options){
			Widget.prototype.initialize.apply(this,arguments);
			this.on("action:pauseplay",this.OnPausePlay);
			this.on("action:getjson",this.OnGetJSON);
			this.InitGameObject();	
		}
		,InitGameObject:function(){
			var self=this;
			if(!this.get("gameClass"))
				return;

			require([this.get("gameClass")],function(Game){
				self.gameObject = new Game({
					'name': 			'untitled game'
					,'resolutionX': 	self.get("parent").GetContainer().innerWidth()
					,'resolutionY': 	self.get("parent").GetContainer().innerHeight() - self.GetContainer().find(".title").outerHeight() - 8
					,'zoom': 			1
					,'scaleMode':		'keepRatio'
					,'domElementId':	(self.get("selector") + "_game")
					,'rendererClass': 	'renderer'
					,'stats':			true
					,'paused': 			true
					,'editor': 			self.get("parent").get("parent")
					,'scenes': 			{
						'bootscene': {
							'isFirstScene': true
							,'configFile': 'assets/scenes/testexport.json'//'/assets/scenes/bootscene.json'
							/*,'name': 		'untitled-scene'
							,'entities': 	[
								{'name':'wut ever'}
								,{'name':'wut ever'}
								,{'name':'wut ever'}
							]*/
						}
					}
				});

				self.get("parent").on("resize",function(){
					self.gameObject.set("resolutionX",self.get("parent").GetContainer().innerWidth());
					self.gameObject.set("resolutionY",self.get("parent").GetContainer().innerHeight() - self.GetContainer().find(".title").outerHeight() - 8);
				});
				var editor = self.get("parent").get("parent");
				
				self.gameObject.on("change:scene",function(){
					editor.set("gameObject",self.gameObject);
					editor.trigger("gameObjectChangedScene",self.gameObject.get("scene"));
				});
				editor.set("gameObject",self.gameObject);

				editor.on("action",function(action){
					if(action == "togglePausePlay"){
						self.gameObject.set("paused",!self.gameObject.get("paused"));
					}
				});
			});
		}
		,DeprecatedOnPausePlay:function(){
			if(!this.gameObject)
				return;
			this.gameObject.set("paused",!this.gameObject.get("paused"))
			this.GetContainer().toggleClass("paused",this.gameObject.get("paused"));
		}
		,DeprecatedOnGetJSON:function(){
			var modal, serialized, scene = this.gameObject.get("scene");
			
			if(!scene)
				return;

			serialized = JSON.stringify(scene.toJSON()).split(',').join(",\n");
			
			modal = this.GetWidgetBody().find(".jsonmodal:first").clone();
			modal.find('.json').html(serialized);
			modal.modal();
		}
	});
});