define(['editor/widget','jquery','tools','underscore','entities/entity','entities/module','scenes/scene'],function(Widget,$,tools,_,Entity,Module,Scene){
	return Widget.extend({
		defaults:_.extend({},Widget.prototype.defaults,{
			'title': 'Object Info'
			,'widgetBodyTemplateFile': 'assets/editor/tpl/widgets/objectinfo.tpl'
			,'targetObject':null
			,'widgetBodyCssClass':'body objectinfo'
		})
		,initialize:function(attributes,options){
			Widget.prototype.initialize.apply(this,arguments);
			var self = this, editor = this.get("parent").get("parent"), target = null;
			
			this.attributes.widget = this;
			this.attributes._ = _;

			editor.on("change:selectedObject",function(){
				self.OnSelectedObjectChanged(this.get("selectedObject"));
			});

			target = editor.get("selectedObject") || this.get("targetObject");

			this.on("action",function(action,element){
				editor.trigger("action",action,element);
			});

			if(target){
				this.OnSelectedObjectChanged(target);
			}
		}
		,OnSelectedObjectChanged:function(obj){
			this.set("targetObject",obj);
			if(this.widgetBody)
				this.widgetBody.remove();

			this.set("mode",null);
			(obj instanceof Entity)&&this.set("mode","entity");
			(obj instanceof Module)&&this.set("mode","module");
			(obj instanceof Scene)&&this.set("mode","scene");

			var newBody = this.GetWidgetBody(true);

			this.GetContainer().append(newBody);
		}
	});
});