define(['editor/widget','jquery','tools','backbone','underscore'],function(Widget,$,tools,$$,_){
	return Widget.extend({
		defaults:_.extend({},Widget.prototype.defaults,{
			'title': 'Tile Tools'
			,'tilemapeditor':null
			,'widgetBodyCssClass':'body tilemap'
			,'widgetBodyTemplateFile':'assets/editor/tpl/widgets/tilemap.tpl'
		})
		,initialize:function(attributes,options){
			if(!attributes.tilemapeditor){
				tools.Warn("tilemap widget can't be initialized without tilemapeditor object");
				return;
			}

			Widget.prototype.initialize.apply(this,arguments);
			var selectedElem = null, self = this, toggleVisible;
			
			this.attributes.widget = this;
			this.attributes._ = _;

			self.attributes.tilemapeditor.on("visible",toggleVisible = function(v){
				if(v){
					self.Show();
				}else{
					self.Hide();
				}
			});
			toggleVisible(self.attributes.tilemapeditor.visible && self.attributes.tilemapeditor.active);

			this.on("action:select",function(elem){
				if(selectedElem){
					selectedElem.removeClass("selected");
				}
				self.attributes.tilemapeditor.brushTile = parseInt(elem.data("tile-index"));
				selectedElem = elem;
				selectedElem.addClass("selected");
			});

			this.on("destroy",function(){
				this.get("parent").widgets.remove(this);
				self.attributes.tilemapeditor.off("visible",toggleVisible);
			});
		}
	});
});