define(['underscore','backbone','jquery','tools','editor/gui'],function(_,$$,$,tools,Gui){
	return $$.Model.extend({
		defaults:{
			targetObject:null
			,parentObject:null
			,role:null
			,gui:null
			,template:null
			,modalTemplate:"assets/editor/tpl/wizard.tpl"
			,silent:false
			,label:""
			,maximize:false
			,isSubGui:false
			,subGuiConfig:null
		}
		,initialize:function(attributes,options){
			this.on("action:save",this.OnSave);
			this.on("action:cancel",this.OnCancel);

			if(!this.get("silent")){
				this.Show();
			}
		}
		,modal:null
		,gui:null
		,Show:function(){
			if(this.get("isSubGui")){
				this.CreateSubGui();
			}else{
				this.CreateModal();
			}
		}
		,CreateModal:function(){
			var self = this, modal = this.get("modalTemplate");
			
			if(self.modal){
				self.modal.remove();
			}
			
			if(!modal){
				return;
			}
			modal = self.modal = $(_.template(tools.FileGetContents(modal),{wizard:this}));

			modal.click(function(e){
				var target = $(e.srcElement || e.target);
				
				if(!target.data("action")){
					if(target.parent(":first").data("action")){
						target = target.parent(":first");
					}else{
						return true;	
					}
				}
				e.preventDefault();
				e.stopPropagation();
				self.trigger("action:"+target.data("action"),target);
			});

			if(this.get("maximize")){
				modal.css({
					'width':$(window).innerWidth()-20
					,'margin-left':($(window).innerWidth()-20) / -2
				});
			}

			modal.modal();
		}
		,GetForm:function(){
			if(!this.get("template"))
				return "";

			return _.template(tools.FileGetContents(this.get("template")),{wizard:this});
		}
		,CreateSubGui:function(){
			if(this.gui){
				this.gui.Hide();
				this.gui.Destroy();
			}

			var self=this, sub = this.gui = new Gui(this.get("subGuiConfig")||undefined);
			
			sub.on("action",function(action,element){
				self.trigger("action:"+action,element);
			});

			this.get("gui").Hide();
		}
		,OnSave:function(){

			//close modal
			if(this.modal){
				this.modal.modal('hide');
			}else if(this.gui){
				this.gui.Hide();
				this.gui.Destroy();
				this.get("gui").Show();
			}

			//dispatch update
			this.trigger("change");
		}
		,OnCancel:function(){
			//close modal
			if(this.modal){
				this.modal.modal('hide');
			}else if(this.gui){
				this.gui.Hide();
				this.gui.Destroy();
				this.get("gui").Show();
			}
		}
	});
});