define(['underscore','editor/wizard','math/vec2','entities/entity','entities/container'],function(_,Wizard,Vec2,Entity,Container){
	return Wizard.extend({
		defaults:_.extend({},Wizard.prototype.defaults,{
			"template":"assets/editor/tpl/wizards/entity.tpl"
			,"label":"Entity"
			,"maximize":false
			,"isSubGui":true
			,"subGuiConfig":{
				'layout':{
					'default':'assets/editor/layouts/entityinspector.json'
				}
				,"selectedObject": null
				,"gameObject":null
				,"isSubGui":true
			}
		})
		,container:null
		,initialize:function(attributes,options){
			var parent = this.get("parentObject"), role= this.get("role");

			if(parent instanceof Container && role == "entities"){
				this.container = parent;
			}

			if(!this.get("targetObject")){
				if(!this.container && this.get("parentObject") && this.get("role")){
					this.set("targetObject", this.get("parentObject").get(this.get("role")));			
				}else{
					this.set("targetObject", new Entity);
				}
			}

			this.attributes.subGuiConfig.selectedObject = this.container?this.get("parentObject"):this.get("targetObject");
			this.attributes.subGuiConfig.gameObject = this.get("gui").get("gameObject");

			Wizard.prototype.initialize.apply(this,arguments);
		}
		,OnSave:function(){
	
			if(this.container && this.container.GetEntityIndex === -1){
				this.container.AddEntity(this.get("targetObject"));
			}else if(this.get("parentObject") && this.get("role")){
				this.get("parentObject").set(this.get("role"),this.get("targetObject"));
			}

			Wizard.prototype.OnSave.apply(this);
		}
	});
});