define(['underscore','editor/wizard','math/vec2'],function(_,Wizard,Vec2){
	return Wizard.extend({
		defaults:_.extend({},Wizard.prototype.defaults,{
			"template":"assets/editor/tpl/wizards/vec2.tpl"
			,"label":"Vector2"
			,"maximize":false
		})
		,initialize:function(attributes,options){
			if(!this.get("targetObject")){
				if(this.get("parentObject") && this.get("role")){
					this.set("targetObject", this.get("parentObject").get(this.get("role")));			
				}else{
					this.set("targetObject", new Vec2);
				}
			}
			Wizard.prototype.initialize.apply(this,arguments);
		}
		,OnSave:function(){
			
			var clone = new Vec2();

			clone.x = parseFloat(this.modal.find("[data-key='x']").val());
			clone.y = parseFloat(this.modal.find("[data-key='y']").val());

			if(this.get("parentObject") && this.get("role")){
				this.get("parentObject").set(this.get("role"),clone);
				this.set("targetObject",clone);
			}

			Wizard.prototype.OnSave.apply(this);
		}
	});
});