define(['backbone','underscore','tools','math/vec2'],function($$,_,tools,Vec2){
	return $$.Model.extend({
		__childEntities:null
		,__drawChildEntities:true
		,AddEntity:function(entity){
			if(this.GetEntityIndex(entity)>-1){
				tools.Error("can't add Entity twice");
				return false;
			}

			this.__childEntities.push(entity);

			entity.set("parent",this);
			entity.set("game",this.get("game"));

			return true;
		}
		,RemoveEntity:function(entity){
			var index = this.GetEntityIndex(entity);
			
			if(index < 0)
				return false;

			entity.set("parent",null);
			this.__childEntities.splice(index,1);

			return true;
		}
		,GetEntityIndex:function(entity){
			if(!this.__childEntities)
				this.__childEntities = [];

			var c = this.__childEntities.length;
			while(c--){
				if(this.__childEntities[c] === entity){
					return c;
				}
			}
			return -1;
		}
		,GetEntityByName:function(name){
			if(!this.__childEntities)
				this.__childEntities = [];
			return _.find(this.__childEntities,function(e){return e.attributes.name == name;});
		}
		,GetEntityById:function(id){
			if(!this.__childEntities)
				this.__childEntities = [];
			return _.find(this.__childEntities,function(e){return e.attributes.id == id;});
		}
		,GetEntityByIndex:function(index){
			if(!this.__childEntities)
				this.__childEntities = [];
			return this.__childEntities.length > index && index > -1 ? this.__childEntities[index] : undefined;
		}
		,SetEntityIndex:function(entity,index){
			if(!this.__childEntities)
				this.__childEntities = [];
			var origIndex;
			if(this.__childEntities.indexOf(entity)<0){
				return false;
			}
			if(index<0||index>entity.length-1){
				return false;
			}
			origIndex = this.GetEntityIndex(entity);
			this.__childEntities.splice(origIndex,1);
			this.__childEntities.splice(i,0,entity);
			return true;
		}
		,LocalToGlobal:function(v2){
			var parent = this, clone = new Vec2(v2);

			clone.x += this.attributes.position.x;
			clone.y += this.attributes.position.y;

			while(parent = parent.get("parent")){
				if(parent.get("position")){
					clone.x += parent.get("position").x;
					clone.y += parent.get("position").y;
				}
			}

		}

		,GlobalToLocal:function(v2){
			var parent = this, clone = new Vec2(v2);

			clone.x -= this.attributes.position.x;
			clone.y -= this.attributes.position.y;

			while(parent = parent.get("parent")){
				if(parent.get("position")){
					clone.x -= parent.get("position").x;
					clone.y -= parent.get("position").y;
				}
			}

			return clone;
		}
	});
});