define(['underscore','backbone','entities/entity','tools'],function(_,$$,entity,tools){
	return $$.Model.extend({
		meta:{
			className:"entities/module"
			,attributes:{
				"name":"String"
			}
		}	
		,defaults:{
			"name": "unnamed-module"
			,"entity":null
		}
		,ready:false
		,initialize:function(attributes,options){
			if(!attributes||!attributes.entity||!(attributes.entity instanceof entity)){
				tools.Error("Entity Modules can't be instantiated without an entity");
				return;
			}

			this.on('change:entity',function(){
				var ent = this.attributes.entity;
				this.trigger("destroy");
				if(ent instanceof Entity)
					this.initialize(this.attributes,options);
			});
			this.on("destroy",this.OnDestroy);
			this.on('ready',function(){this.ready = true;});
		}
		,toJSON:function(){
			var copy = _.clone(this.attributes);
			delete copy.entity;
			return copy;
		}
		,OnDestroy:function(){
			this.ready = false;
			this.off();
		}
	});
});