define(['entities/module','sprites/sprite'],function(Module,Sprite){
	return Module.extend({
		defaults:_.extend({},Module.prototype.defaults,{
			'name':				'unnamed-sprite'
			,'sheet': 			null
			,'sheetObject':		null
		})
		,initialize:function(attributes,options){
			Module.prototype.initialize.call(this,attributes,options);
			if(this.attributes.sheet){
				this.InitSheet();
			}
		}
		,InitSheet:function(){
			var self = this, ent = this.attributes.entity, spriteSheet = new Sprite(this.get('sheet'));
			
			if(spriteSheet.ready){
				ent.texture = spriteSheet.texture;
				self.trigger("ready");
			}else{
				spriteSheet.on("ready",function(){
					ent.texture = spriteSheet.texture;
					self.trigger("ready");
				});
			}
			this.set('sheetObject',spriteSheet);

			this.on('destroy',function(){
				ent.texture = null;
				this.attributes.sheetObject.trigger("destroy");
				this.attributes.sheetObject = null;
			});
		}
		,toJSON:function(){
			var copy = Module.prototype.toJSON.call(this);
			delete copy.sheetObject;
			return copy;
		}
	});
});