define(['entities/modules/sprite','entities/module','tools','underscore'],function(Sprite,Module,tools,_){
	return Module.extend({
		defaults:_.extend({},Module.prototype.defaults,{
			'name':				'unnamed-sprite-animation'
			,'sprite':			null
			,'defaultPreset': 	null
			,'presets':			null
			/*,'presets':		{
				'my-preset': {
					frames:{
						[0,100]
						,[1,200]
						,[2,100]
					}
					,repeat:1
				}
			}*/
		})
		,spriteObj:null
		,currentAnimation:null
		,initialize:function(attributes,options){
			Module.prototype.initialize.call(this,attributes,options);
			var self = this,update;

			this.spriteObj = attributes.sprite?attributes.entity.GetModuleByName(attributes.sprite):attributes.entity.GetModuleByClass(Sprite);

			if(this.spriteObj){
				this.spriteObj.on("destroy",function(){
					self.trigger("change:entity");
				});
				if(this.spriteObj.ready){
					if(this.get("defaultPreset")){
						this.SetAnimation(this.get("defaultPreset"));
					}
					self.trigger("ready");
				}else{
					this.spriteObj.on("ready",function(){
						if(self.get("defaultPreset")){
							self.SetAnimation(self.get("defaultPreset"));
						}
						self.trigger("ready");
					});
				}
			}else{
				tools.Warn(this.get("name") + ": could not find Sprite");
				this.trigger("ready");
			}

			attributes.entity.on("update",(update = function(time,delta){self.OnUpdate(time,delta)}));

			this.on("destroy",function(){
				attributes.entity.off("update",update);
				this.spriteObj.trigger("destroy");
				this.spriteObj = null;
				this.currentAnimation = null;
			});
		}
		,SetAnimation:function(config){
			if(!this.spriteObj)
				return false;
			
			config = _.isString(config)&&this.attributes.presets?this.attributes.presets[config]:config;
			
			if(!_.isObject(config) || !config.frames || !config.frames.length)
				return false;

			var c = this.currentAnimation = _.extend({},config);
			c.repeat = c.repeat!==undefined?c.repeat:1;
			
			c.repeatCount = 0;
			c.frameIndex = 0;
			c.frameTime = 0;
			c.elapsedTime = 0;

			this.spriteObj.attributes.sheetObject.SetIndex(c.frames[c.frameIndex][0]);

			return true;
		}
		,Stop:function(){
			if(this.currentAnimation){
				this.currentAnimation = null;
			}
			return this;
		}
		,OnUpdate:function(time,delta){
			if(!this.ready || !this.spriteObj || !this.currentAnimation){
				return;
			}
			var s = this.spriteObj, c=this.currentAnimation;
			c.elapsedTime += delta;

			if(c.frameTime + c.frames[c.frameIndex][1] < c.elapsedTime){
				c.frameTime = c.elapsedTime;
				
				if(c.frameIndex+1 < c.frames.length){
					++c.frameIndex;
				}else if(c.repeat === 0){
					c.frameIndex = 0;
				}else if(c.repeat>c.repeatCount+1){
					++c.repeatCount;
					c.frameIndex = 0;
				}else{
					this.trigger("animation-complete");
					this.currentAnimation = null;
					return;
				}

				s.attributes.sheetObject.SetIndex(c.frames[c.frameIndex][0]);
			}
		}
	});
});