define(['entities/module','entities/modules/tilemap', 'math/vec2'],function(Module,Tilemap, Vec2){
	return Module.extend({
		defaults:_.extend({},Module.prototype.defaults,{
			'name':			'unnamed-tilemap-controls'
			,'smooth':		16
			,'stepsize':	10
		})
		,ready:true
		,targetPosition:null
		,initialize:function(attributes,options){
			Module.prototype.initialize.call(this,attributes,options);

			this.targetPosition = new Vec2;

			this.AttachControls();		

		}
		,AttachControls:function(){
			var self=this, ent=this.get("entity"),update;

			function attach(){
				self.keyboard = ent.get("game").GetKeyboard();

				ent.on("update",(update = function(time,delta){
					self.OnUpdate();
				}));
			}

			if(ent.ready){
				attach();
			}else{
				ent.on("ready",attach);
			}

			this.on("destroy",function(){
				ent.off("ready",attach);
				ent.off("update",update);
				self.keyboard = null;
				this.spriteObj.trigger("destroy");
			});
		}
		,MoveTo:function(x, y){

			this.targetPosition.x += x || 0;
			this.targetPosition.y += y || 0;

			var ent = this.get("entity"), buff = ent.get("game").get("buffer");

			/*if(this.targetPosition.x < - ent.texture.width + buff.width){
				this.targetPosition.x = - ent.texture.width + buff.width;
			}
			if(this.targetPosition.x > 0){
				this.targetPosition.x = 0;
			}

			if(this.targetPosition.y < - ent.texture.height + buff.height){
				this.targetPosition.y = - ent.texture.height + buff.height;
			}
			if(this.targetPosition.y > 0){
				this.targetPosition.y = 0;
			}*/

		}
		,OnUpdate:function(){
			var ent = this.attributes.entity;
			ent.attributes.position.x += (this.targetPosition.x - ent.attributes.position.x) / this.attributes.smooth;
			ent.attributes.position.y += (this.targetPosition.y - ent.attributes.position.y) / this.attributes.smooth;

			if(this.keyboard.IsDown("left-arrow")){
				this.MoveTo(-this.get("stepsize"));
			}
			if(this.keyboard.IsDown("right-arrow")){
				this.MoveTo(this.get("stepsize"));
			}
			if(this.keyboard.IsDown("up-arrow")){
				this.MoveTo(0,-this.get("stepsize"));
			}
			if(this.keyboard.IsDown("down-arrow")){
				this.MoveTo(0,this.get("stepsize"));
			}
		}
	});
});