define(['backbone','underscore','tools'],function($$,_,tools){
	return $$.Model.extend({
		defaults:{
			'file':null
		}
		,Assemble:function(){
			if(!_.isString(this.attributes.file)){
				return false;
			}

			var tmp = this.ParseShader(this.attributes.file);

			return tmp&&tmp.length?tmp:false;
		}
		,ParseShader:function(file){
			var shader = "", lines, src, include;

			src = tools.FileGetContents(file);

			if(!src || !src.length)
				return "";

			lines = src.split("\n");

			for(var i=0; i<lines.length; ++i){
				if(/^\s*#pragma\s+include/g.test(lines[i])){
					include = this.ParseIncludeLine(lines[i]);
					if(!_.isString(include)){
						console&&console.warn("invalid \"#pragma include\" in shader \""+file+"\" at line "+i);
					}else{
						shader += include + "\n";
					}
				}else{
					shader += lines[i] + "\n";
				}
			}
			return shader;
		}
		,ParseIncludeLine:function(line){
			var r = /([""'])(?:(?=(\\?))\2.)*?\1/g, file = r.exec(line);
			if(!file||!(file=file[0].substr(1,file[0].length-2))){
				return false;
			}
			return this.ParseShader(file);
		}
	});
});