precision mediump float;
  uniform vec2 resolution;
  uniform float time;
  uniform sampler2D text;

  void main () {
    vec2 p = gl_FragCoord.xy / resolution.xy;

    vec3 bg = vec3(p.x*0.5, p.y*0.5, 0.2);
    vec3 textColor = vec3(p.x, 0.7+0.3*cos(0.01*time), 0.7+0.3*sin(0.01*time));

    // Some wave effect on the coordinate to lookup in the text texture
    float waveAmp = 0.01+0.10*(1.0 + sin(time*0.001));
    float waveSpeed = time*0.01;
    float waveMag = 20.0 + 15.*cos(3.+time*0.000111);
    vec2 coord = p*vec2(1.0, 2.)-vec2(0.0, 0.5)+vec2(0., waveAmp*sin(waveSpeed+p.x*waveMag));
    vec4 t = texture2D(text, coord);

    // Use the texture alpha to determine where the text is
    // Multiply our text color with the texture color to use as a color intensity (original text uses a greyscale)
    vec3 c = mix(bg, textColor*t.rgb, t.a);
    gl_FragColor = vec4(c, 1.0);
  }