struct ConstantSpritesheet {
  vec2 size; // size of img in pixels
  vec2 tileSize; // size of one tile in pixels
};

// Spritesheets
vec4 drawSprite (vec2 p, ConstantSpritesheet s, sampler2D img, ivec2 tile, vec2 pos, vec2 size) {
  vec2 absP = p*resolution.xy;
  bool inSprite = all(lessThan(pos, absP)) && all(lessThan(absP, pos+size));
  if (inSprite) {
    vec2 tileRatio = s.tileSize/s.size;
    vec2 tilePosition = vec2(tile)*tileRatio;
    p -= pos/resolution.xy;
    p /= size/resolution.xy;
    return texture2D(img, p*tileRatio+tilePosition);
  }
  else {
    return vec4(0.0, 0.0, 0.0, 0.0);
  }
}
vec4 drawSprite (vec2 p, ConstantSpritesheet s, sampler2D img, ivec2 tile, vec2 pos) {
  return drawSprite(p, s, img, tile, pos, s.tileSize);
}