define(['entities/module'],function(Module){
	return Module.extend({
		defaults:_.extend({},Module.prototype.defaults,{
			'name':				'unnamed-playercontrols'
		})
		,keyboard:null
		,currentAnimation:null
		,initialize:function(attributes,options){
			Module.prototype.initialize.call(this,attributes,options);
			if(this.attributes.entity.ready){
				this.InitControls();
			}else{
				var self=this;
				this.attributes.entity.on("ready",function(){
					self.InitControls();
				});
			}
			this.trigger("ready");
		}
		,InitControls:function(){
			var self=this, animations = this.get("entity").GetModuleByName("animations");
			this.keyboard = this.get("entity").get("game").GetKeyboard();

			this.get("entity").on("update",function(){
				var newAnimation = null;
				if(self.keyboard.IsDown('left-arrow')){
					newAnimation = 'walkleft';
				}
				if(self.keyboard.IsDown('right-arrow')){
					newAnimation = 'walkright';
				}
				if(self.keyboard.IsDown('up-arrow')){
					newAnimation = 'walkup';
				}
				if(self.keyboard.IsDown('down-arrow')){
					newAnimation = 'walkdown';
				}

				if(self.currentAnimation != newAnimation){
					self.currentAnimation = newAnimation;
					if(newAnimation){
						animations.Stop().SetAnimation(newAnimation);
					}else{
						animations.Stop();
					}
				}
			});
		}
	});
});