define(['underscore'],function(){
	var shims = {};

	// requestAnimationFrame polyfill by Erik Möller
	// fixes from Paul Irish and Tino Zijdel

	(function() {
	    var lastTime = 0;
	    var vendors = ['ms', 'moz', 'webkit', 'o'];

	    for(var x = 0; x < vendors.length && !window.requestAnimationFrame; ++x) {
	        window.requestAnimationFrame = window[vendors[x]+'RequestAnimationFrame'];
	        window.cancelAnimationFrame = window[vendors[x]+'CancelAnimationFrame'] 
	                                   || window[vendors[x]+'CancelRequestAnimationFrame'];
	    }
	 
	    if (!window.requestAnimationFrame)
	        window.requestAnimationFrame = function(callback, element) {
	            var currTime = new Date().getTime();
	            var timeToCall = Math.max(0, 16 - (currTime - lastTime));
	            var id = window.setTimeout(function() { callback(currTime + timeToCall); }, 
	              timeToCall);
	            lastTime = currTime + timeToCall;
	            return id;
	        };
	 
	    if (!window.cancelAnimationFrame)
	        window.cancelAnimationFrame = function(id) {
	            clearTimeout(id);
	        };
	}());


	return {
		FileGetContents:function(path){
			var request = window.XMLHttpRequest?new window.XMLHttpRequest:new ActiveXObject("Microsoft.XMLHTTP");
			
			if(request){
				request.open("GET",path,false);
				request.send(null);
				return request.responseText;
			}else{
				return false;
			}
  		}
  		,FileGetJSON:function(path){
  			var contents = this.FileGetContents(path);

  			if(!contents)
  				return null;

  			try{
  				return JSON.parse(contents);
  			}catch(e){
  				this.Warn("could not parse json file "+path+": "+e.message);
  				return null;
  			}
  		}
  		,LoadImage:function(path,callback){
  			try{
  				var img = new Image();
				img.addEventListener("load",function(){
					callback&&callback(img);
				});
				img.src = path;
  			}catch(e){}
  		}
  		,Log:function(){
  			console&&console.log&&console.log.apply(console,arguments);
  		}
  		,Dir:function(){
  			console&&console.dir&&console.dir.apply(console,arguments);
  		}
  		,Warn:function(){
  			console&&console.warn&&console.warn.apply(console,arguments);
  		}
  		,Error:function(){
  			console&&console.error&&console.error.apply(console,arguments);	
  		}
  		,shims:shims
	};
});